/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufUK;

public abstract class AbstractWahlbeteiligungVerlaufDAO extends de.ivu.elect.jee.entity.AbstractDAO<WahlbeteiligungVerlauf,
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK
    , WahlbeteiligungVerlaufUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractWahlbeteiligungVerlaufDAO.class);

  public AbstractWahlbeteiligungVerlaufDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public WahlbeteiligungVerlauf findByPrimaryKey(
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected WahlbeteiligungVerlauf findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(WahlbeteiligungVerlauf.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM WahlbeteiligungVerlauf o WHERE o.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<WahlbeteiligungVerlauf> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("WAHLBETEILIGUNG_VERLAUF.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("WahlbeteiligungVerlauf, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufUK uk,
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf findByUK(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufUK uk){

    try {
     return (de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlauf) getEntityManager().createNamedQuery("WAHLBETEILIGUNG_VERLAUF.UK")
                  .setParameter(1, uk
                .getDatum ()

              )
             .setParameter(2, uk
                .getName ()

              )
             .setParameter(3, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(4, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(5, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(6, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(7, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("WahlbeteiligungVerlauf, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}